#!/bin/sh
KVER=`grep -i 'kernel.*version' CONTENTS |head -1|sed -e 's/\([^0-9]*\)\([0-9a-z.\-]*\)\(.*\)/\2/'`
BVER=`grep -i 'based.*version' CONTENTS |head -1|sed -e 's/\([^0-9]*\)\([0-9a-z.\-]*\)\(.*\)/\2/'`
V1=`echo $BVER|cut -f1 -d.`
V2=`echo $KVER|cut -f1 -d.`
P1=`echo $BVER|cut -f2 -d.`
P2=`echo $KVER|cut -f2 -d.`
S1=`echo $BVER|cut -f3- -d.|sed -e 's/^\([0-9]*\).*/\1/'`
S2=`echo $KVER|cut -f3- -d.|sed -e 's/^\([0-9]*\).*/\1/'`
E1=`echo $BVER|cut -f3- -d.|sed -e 's/^[0-9]*//'`
if [ ! -z "$E1" ]; then
   E1=" $E1";
fi
E2=`echo $KVER|cut -f3- -d.|sed -e 's/^[0-9]*//'`
cat << EOF
--- linux-$BVER/Makefile	Sun Sep 23 18:49:13 2001
+++ linux-$KVER/Makefile	Sun Sep 23 18:55:55 2001
@@ -1,4 +1,6 @@
-VERSION = $V1
-PATCHLEVEL = $P1
-SUBLEVEL = $S1
-EXTRAVERSION =$E1
+VERSION = $V2
+PATCHLEVEL = $P2
+SUBLEVEL = $S2
+ifeq "\$(EXTRAVERSION)" ""
+EXTRAVERSION = $E2
+endif
EOF
